#!/usr/bin/python2
#-*-coding:utf-8-*-
#
# Copyright (C) 2005 Red Hat, Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

import os
import os.path
import gtk
import commands
import time
import glib
import gobject
import subprocess

from config import *

import menutreemodel
#from threading import Timer
#import thread


class MenuEditorDialog:
    def __init__ (self):
        if os.getuid() != 0 :
           self.__info_dialog("This Application need root permission!")        
           exit()

        ui_file = os.path.join (UI_DIR, "remove-software.ui")
        self.ui = gtk.Builder()
        self.ui.set_translation_domain (PACKAGE)
        self.ui.add_from_file(ui_file)
        self.window = self.ui.get_object ("menu_editor_window")
        self.window.connect ("destroy", gtk.main_quit)
        #self.window.set_default_response (gtk.RESPONSE_ACCEPT)
        self.window.set_icon_name ("system-software-install")
    
        self.window_width = 800
        self.window_height = 600
        self.menu_width = self.window_width / 6 
        self.window.set_default_size(self.window_width,self.window_height)
        self.window.set_position(gtk.WIN_POS_CENTER_ALWAYS)

        #select button 
        self.select_button = self.ui.get_object ("select_button")
        self.select_button.set_active(False)
        self.user_select = False
        self.select_button.connect  ("clicked",self.__select_button_clicked)
    
        #delete button 
        self.delete_button = self.ui.get_object ("delete_button")
        self.delete_button.connect  ("clicked",self.__delete_button_clicked)
        self.delete_button.set_sensitive(False)

        self.menus_tree   = self.ui.get_object ("menus_treeview")
        self.entries_list = self.ui.get_object ("applications_treeview")

        self.menu_tree_model = menutreemodel.MenuTreeModel ()
        
        self.current_iter = None
        self.current_path = None


        self.paned = self.ui.get_object("hpaned1")
        self.paned.set_position(self.menu_width)
        self.__setup_menus_tree ()
        self.__setup_entries_list ()

        self.window.show ()
    
    def __select_button_clicked (self,widget,data=None):
        if self.user_select : #用户选择行
            return 
        if widget.get_active() :
            self.__all_select_noselect(self._iter,True)
            self.delete_button.set_sensitive(True)
        else :
            self.__all_select_noselect(self._iter,False)
            self.delete_button.set_sensitive(False)

    def __all_select_noselect (self, parent_iter = None, value = True):
        model = self.menu_tree_model
        
        iter = model.iter_children (parent_iter)
        while iter:
            if model[iter][model.COLUMN_IS_ENTRY]:
                model[iter][model.COLUMN_DELETE] = value
            else:
                self.__all_select_noselect (iter,value)
            
            iter = model.iter_next (iter)

    #赋值此列的rpm包名
    def __set_rpm_name(self):
        model = self.menu_tree_model
        #remove_files = [ ] #删除desktop文件，无所属rpm包

        #确定列的rpm包名
        iter = model.iter_children (self._iter)
        while iter:
            if model[iter][model.COLUMN_IS_ENTRY] :
                if model[iter][model.COLUMN_RPM] : #已经赋值过,退出函数
                    return 
                command = "rpm -qf \"" +  model[iter][model.COLUMN_FILE_PATH] + "\""
                (status,rpmname) = commands.getstatusoutput(command)
                if status != 0 : 
                    rpmname = "N/A"
                    #remove_files.append(model[iter][model.COLUMN_FILE_PATH])
                model[iter][model.COLUMN_RPM] = rpmname
            iter = model.iter_next (iter)

    def __question_dialog(self,str):
        dialog = gtk.Dialog("Remove Software confirm",  
                        None,  
                        gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
                    (gtk.STOCK_CANCEL, gtk.RESPONSE_REJECT,gtk.STOCK_OK, gtk.RESPONSE_ACCEPT) )
        dialog.set_default_size(492,160)
        dialog.set_position(gtk.WIN_POS_CENTER_ALWAYS)
        #dialog.set_has_separator(False)
        #dialog.set_decorated(False)
	

        label = gtk.Label(str)
        dialog.vbox.pack_start(label)
        label.show() #must

        response = dialog.run()
        label.hide()
        dialog.hide_all()
        dialog.destroy()
        if response == gtk.RESPONSE_ACCEPT :
            return False
        else :
            return True

    def __info_dialog(self,str):
        dialog = gtk.Dialog("Remove Software",  
                        None,  
                        gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
                    (gtk.STOCK_OK, gtk.RESPONSE_ACCEPT) )
        dialog.set_default_size(492,160)
        dialog.set_position(gtk.WIN_POS_CENTER_ALWAYS)

        label = gtk.Label(str)
        dialog.vbox.pack_start(label)
        label.show()

        response = dialog.run()
        dialog.destroy()

    def __delete_button_clicked (self,widget,data=None):
        remove_rpms = [ ] #删除软件包
        remove_names = [ ] #删除应用名
        dep_remove_names = [ ] #删除依赖应用名
        remove_iters = [ ]  #删除行
        #remove_files = [ ] #删除desktop文件，无所属rpm包

        #remove_files = self.__set_rpm_name()
        self.__set_rpm_name()
        
        model = self.menu_tree_model
        #确定删除rpm包
        iter = model.iter_children (self._iter)
        while iter:
            if model[iter][model.COLUMN_IS_ENTRY] :
                if  model[iter][model.COLUMN_DELETE]:
                    remove_names.append(model[iter][model.COLUMN_NAME])
                    if model[iter][model.COLUMN_RPM] not in remove_rpms :
                        remove_rpms.append(model[iter][model.COLUMN_RPM])
            iter = model.iter_next (iter)

        if remove_rpms is None: #无删除包
            return 

        #确定删除应用
        iter = model.iter_children (self._iter)
        while iter:
            if model[iter][model.COLUMN_IS_ENTRY] :
                if model[iter][model.COLUMN_RPM] in  remove_rpms :
                    remove_iters.append(iter)
                    if model[iter][model.COLUMN_NAME] not in remove_names :
                        dep_remove_names.append(model[iter][model.COLUMN_NAME])
                        
            iter = model.iter_next (iter)

        #print "remove_names",remove_names
        #print "dep_remove_names",dep_remove_names
        

        #确定是否删除
        str_remove_names = '\n'.join(remove_names)
        if dep_remove_names : #非空
            str_dep_remove_names = '\n'.join(dep_remove_names)
            question = "Please confirm if removing these Applications?\n" + str_remove_names + "\n ( for belong to the same software, it's need to remove these applications also. ) \n" + str_dep_remove_names
        else :
            question = "Please confirm if removing these Applications?\n" + str_remove_names 
        if self.__question_dialog(question): #no choose ok
            return

        #开启提示框
        remove_rpms.insert(0, "info-remove-software")
        self.process = subprocess.Popen(remove_rpms)
	gobject.timeout_add(10, self._waitForUninstallProcess, self.process,model,remove_iters)


    def _waitForUninstallProcess(self,process,model,remove_iters):
	if process.poll() != None: #finish
        	#删除包结束
	        self.select_button.set_active(False)
        	self.delete_button.set_sensitive(False)

	        #隐藏被删除行
        	for iter in remove_iters : 
	            model.remove(iter)

        	#设置按钮状态
	        self.__set_buttons_state(self._iter)

	        subprocess.call(["xdg-desktop-menu forceupdate"], shell=True)

        	#开启结束提示对话框
	        self.__info_dialog("Removing software is over!") #no choose ok
		return False

	return True
    
    def __is_menu_tree_directory (self, model, iter):
        return not model[iter][self.menu_tree_model.COLUMN_IS_ENTRY]

    def __setup_menus_tree (self):
        self.menus_model = self.menu_tree_model.filter_new ()
        self.menus_model.set_visible_func (self.__is_menu_tree_directory)
        self.menus_tree.set_model (self.menus_model)
        
        self.menus_tree.get_selection ().set_mode (gtk.SELECTION_BROWSE)
        self.menus_tree.get_selection ().connect ("changed", self.__menus_selection_changed)
        self.menus_tree.set_headers_visible (False)

        column = gtk.TreeViewColumn (_("Name"))
        column.set_spacing (6)
        #column.set_sizing(gtk.TREE_VIEW_COLUMN_FIXED)
        #column.set_fixed_width(self.menu_width)

        cell = gtk.CellRendererPixbuf ()
        column.pack_start (cell, False)
        column.set_attributes (cell, pixbuf = self.menu_tree_model.COLUMN_ICON)

        cell = gtk.CellRendererText ()
        column.pack_start (cell, True)
        column.set_attributes (cell, text = self.menu_tree_model.COLUMN_NAME)
                                
        self.menus_tree.append_column (column)

        self.menus_tree.expand_all ()

    def __setup_entries_list (self):
        self.entries_list.get_selection ().set_mode (gtk.SELECTION_SINGLE)
        self.entries_list.set_headers_visible (True)

        column = gtk.TreeViewColumn (_("Select"))
        column.set_min_width(50)
        self.entries_list.append_column (column)
        
        cell = gtk.CellRendererToggle ()
        cell.connect ("toggled", self.__on_hide_toggled) #need to modify
        column.pack_start (cell, False)
        column.set_alignment(0.5)
        column.set_attributes (cell, active = self.menu_tree_model.COLUMN_DELETE)

    	#name
        column = gtk.TreeViewColumn (_("Name"))
        column.set_spacing (4)
        self.entries_list.append_column (column)

        cell = gtk.CellRendererPixbuf ()
        column.pack_start (cell, False)
        column.set_attributes (cell, pixbuf = self.menu_tree_model.COLUMN_ICON)

        cell = gtk.CellRendererText ()
        column.pack_start (cell, True)
        column.set_alignment(0.5)
        column.set_attributes (cell, text = self.menu_tree_model.COLUMN_NAME)

	    #comment
        column = gtk.TreeViewColumn (_("Comment"))
        self.entries_list.append_column (column)

        cell = gtk.CellRendererText ()
        column.pack_start (cell, True)
        column.set_alignment(0.5)
        column.set_attributes (cell, text = self.menu_tree_model.COLUMN_COMMENT)


    def __on_hide_toggled (self, toggle, path):
        def toggle_value (model, iter, column):
            model[iter][column] = not model[iter][column]

        child_path = self.entries_model.convert_path_to_child_path (path)
        child_iter = self.menu_tree_model.get_iter (child_path)
        
        toggle_value (self.menu_tree_model, child_iter, self.menu_tree_model.COLUMN_DELETE)


        if not self.menu_tree_model[child_iter][self.menu_tree_model.COLUMN_DELETE]: #cancel select
            self.user_select = True
            self.__set_buttons_state(self._iter)
            #self.select_button.set_active(False)   
            self.user_select = False
        else :
            self.__set_buttons_state(self._iter)


    #select_button
    #delete_button
    def __set_buttons_state(self,parent_iter):
        model = self.menu_tree_model
        bSelected = False
        bNotSelected = False
        
        iter = model.iter_children (parent_iter)
        while iter:
            if model[iter][model.COLUMN_IS_ENTRY]:
                if model[iter][model.COLUMN_DELETE] : #选择
                    bSelected = True
                else: #没选择
                    bNotSelected = True    
            
            iter = model.iter_next (iter)

        if bSelected:
            self.delete_button.set_sensitive(True)
            if not bNotSelected :
                self.select_button.set_active(True)
        else:
            self.delete_button.set_sensitive(False)
    
        if bNotSelected :
            self.select_button.set_active(False)

    def __menus_selection_changed (self, selection):
        (model, iter) = selection.get_selected ()
        if not iter:
            self.entries_list.set_model (None)
            return

        if iter:
            iter = model.convert_iter_to_child_iter (iter)
        
        self.entries_model = self.menu_tree_model.filter_new (self.menu_tree_model.get_path (iter))
        self.entries_model.set_visible_column (self.menu_tree_model.COLUMN_IS_ENTRY)
        self.entries_list.set_model (self.entries_model)
        self._iter = iter
        self._selection = selection

        self.__set_buttons_state(self._iter)
